diff -uNr fwbuilder-2.1.8/src/ipt/PolicyCompiler_ipt.cpp fwbuilder-2.1.9/src/ipt/PolicyCompiler_ipt.cpp
--- fwbuilder-2.1.8/src/ipt/PolicyCompiler_ipt.cpp	2006-11-10 06:24:48.000000000 +0100
+++ fwbuilder-2.1.9/src/ipt/PolicyCompiler_ipt.cpp	2007-01-15 05:37:52.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: PolicyCompiler_ipt.cpp,v 1.56 2006/11/10 05:24:48 vkurland Exp $
+  $Id: PolicyCompiler_ipt.cpp,v 1.64 2007/01/15 04:37:52 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -89,8 +89,12 @@
     ostringstream  ostr;
     string name=at->getName();
     string::size_type p1;
-    while ( (p1=name.find(" "))!=string::npos)
-        name=name.replace(p1,1,"_");
+    char *bad_shell_chars = " !#$&*()-+=\\|{}[]?<>,.";
+    for (char *cptr=bad_shell_chars; *cptr; cptr++)
+    {
+        while ( (p1=name.find(*cptr))!=string::npos)
+            name=name.replace(p1,1,"_");
+    }
     ostr << "at_" << name;
     return ostr.str();
 }
@@ -453,6 +457,88 @@
 }
 #endif
 
+
+/*
+ * This rule processor converts non-terminating targets CLASSIFY and
+ * MARK to terminating targets (equivalent) by splitting the rule and
+ * adding one more rule with target ACCEPT.
+ *
+ * Call this rule processor at the very end of the chain when all
+ * splits are done and target is set via "ipt_target"
+ */
+bool  PolicyCompiler_ipt::splitNonTerminatingTargets::processNext()
+{
+    PolicyRule *rule=getNext(); if (rule==NULL) return false;
+    string tgt = rule->getStr("ipt_target");
+    FWOptions      *ruleopt = rule->getOptionsObject();
+    
+    if (compiler->fw->getOptionsObject()->getBool("classify_mark_terminating") &&
+        !ruleopt->getBool("already_terminating_target") &&
+        (tgt=="CLASSIFY" || tgt=="MARK"))
+    {
+        RuleElementSrc *nsrc;
+        RuleElementDst *ndst;
+        RuleElementSrv *nsrv;
+        RuleElementItf *nitfre;
+        PolicyRule     *r, *r2;
+
+        string this_chain = rule->getStr("ipt_chain");
+        string new_chain  = this_chain;
+
+        nsrc = rule->getSrc();
+        ndst = rule->getDst();
+        nsrv = rule->getSrv();
+        nitfre = rule->getItf();
+
+        if (!nsrc->isAny() ||
+            !ndst->isAny() ||
+            !nsrv->isAny() ||
+            !nitfre->isAny())
+        {
+            new_chain   =PolicyCompiler_ipt::getNewTmpChainName(rule);
+            r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+            compiler->temp_ruleset->add(r);
+            r->duplicate(rule);
+            r->setStr("subrule_suffix","ntt");
+            r->setStr("ipt_target",new_chain);
+            tmp_queue.push_back(r);
+        }
+
+        r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+        compiler->temp_ruleset->add(r);
+        r->duplicate(rule);
+        nsrc = r->getSrc();   nsrc->reset();
+        ndst = r->getDst();   ndst->reset();
+        nsrv = r->getSrv();   nsrv->reset();
+        nitfre = r->getItf(); nitfre->reset();
+        r->setInterfaceId("");
+        ruleopt = r->getOptionsObject();
+        ruleopt->setInt("limit_value",-1);
+        ruleopt->setInt("limit_value",-1);
+        ruleopt->setInt("connlimit_value",-1);
+        ruleopt->setInt("hashlimit_value",-1);
+        ruleopt->setBool("stateless",true);
+        r->setLogging(false);
+	r->setStr("ipt_chain",new_chain);
+        r->setStr("upstream_rule_chain",this_chain);
+        tmp_queue.push_back(r);
+
+        r2= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+        compiler->temp_ruleset->add(r2);
+        r2->duplicate(r);
+        r2->setAction(PolicyRule::Accept);
+        r2->setStr("ipt_target","ACCEPT");
+        ruleopt = r2->getOptionsObject();
+        ruleopt->setBool("stateless",true);
+        tmp_queue.push_back(r2);
+
+        return true;
+    }
+
+    tmp_queue.push_back(rule);
+    return true;
+}
+
 // this version just splits rule so that each elementary rule is associated
 // with one interface.
 
@@ -523,6 +609,8 @@
         for (FWObject::iterator i=subset->begin(); i!=subset->end(); i++)
         {
             PolicyRule *r = PolicyRule::cast(*i);
+            if (r->isDisabled()) continue;
+
             RuleElementItf *itfre=r->getItf();   assert(itfre);
 
             if (itfre->isAny())
@@ -626,6 +714,9 @@
  * CLASSIFY only works in mangle table in POSTROUTING chain.
  * the man page does not mention this, but module documentation
  * in p-o-m says so.
+ *
+ * per bug #1618329: "Wrong in-code comment" this comment is incorrect,
+ * CLASSIFY target is valid in POSTROUTING, OUTPUT and FORWARD chains.
  */
 bool PolicyCompiler_ipt::dropMangleTableRules::processNext()
 {
@@ -1353,7 +1444,38 @@
     return true;
 }
 
+bool PolicyCompiler_ipt::setChainForMangle::processNext()
+{
+    PolicyCompiler_ipt *ipt_comp=dynamic_cast<PolicyCompiler_ipt*>(compiler);
+    PolicyRule *rule=getNext(); if (rule==NULL) return false;
+
+    if (ipt_comp->my_table=="mangle" && rule->getStr("ipt_chain")=="")
+    {
+        if (rule->getDirection()==PolicyRule::Inbound)
+            rule->setStr("ipt_chain","PREROUTING");
+
+        if (rule->getDirection()==PolicyRule::Outbound)
+            rule->setStr("ipt_chain","POSTROUTING");
+    }
+
+    tmp_queue.push_back(rule);
+    return true;
+}
 
+/*
+ * couple of special cases for rules with action Tag
+ *
+ * option 'ipt_mark_connections' means we need to generate two rules:
+ * one with target MARK and another with target CONNMARK. We place
+ * these two new rules in a separate chain.
+ *
+ * if global option 'classify_mark_terminating' is also on, we place third rule in
+ * the same chain, this time with action ACCEPT.
+ *
+ * Note that if option 'ipt_mark_connections' is off, we do not process
+ * classify_mark_terminating option here. It will be processed later in 
+ * splitNonTerminatingTargets
+ */
 bool PolicyCompiler_ipt::splitIfTagAndConnmark::processNext()
 {
     PolicyRule *rule=getNext(); if (rule==NULL) return false;
@@ -1365,12 +1487,16 @@
     RuleElementDst      *ndst;
     RuleElementSrv      *nsrv;
     RuleElementInterval *nint;
-    
+    bool                 make_terminating = compiler->fw->getOptionsObject()->getBool("classify_mark_terminating");
+
     if (rule->getAction() == PolicyRule::Tag &&
         ruleopt->getBool("ipt_mark_connections"))
     {
 	PolicyRule *r, *r1;
 
+        if (make_terminating)
+            ruleopt->setBool("already_terminating_target",true);
+
         string this_chain  =rule->getStr("ipt_chain");
 	string new_chain=PolicyCompiler_ipt::getNewChainName(rule,rule_iface);
 
@@ -1382,6 +1508,9 @@
         r->setAction(PolicyRule::Continue);
 	r->setLogging(false);
         ruleopt =r->getOptionsObject();
+        if (make_terminating)
+            ruleopt->setBool("already_terminating_target",true);
+
 	tmp_queue.push_back(r);
 
 	r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
@@ -1400,6 +1529,9 @@
 	ndst=r->getDst();   ndst->reset();
 	nsrv=r->getSrv();   nsrv->reset();
 	if ( (nint=r->getWhen())!=NULL )  nint->reset();
+        if (make_terminating)
+            ruleopt->setBool("already_terminating_target",true);
+
 	tmp_queue.push_back(r);
 
 	r1= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
@@ -1410,8 +1542,22 @@
         r1->setLogging(false);
         ruleopt =r1->getOptionsObject();
         ruleopt->setStr("CONNMARK_arg","--save-mark");
+        if (make_terminating)
+            ruleopt->setBool("already_terminating_target",true);
+
 	tmp_queue.push_back(r1);
 
+        if (make_terminating)
+        {
+            r1= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+            compiler->temp_ruleset->add(r1);
+            r1->duplicate(r);
+            r1->setStr("ipt_target","ACCEPT");
+            r1->setAction(PolicyRule::Accept);
+            r1->setLogging(false);
+            tmp_queue.push_back(r1);
+        }
+
         ipt_comp->have_connmark = true;
 
     } else
@@ -1427,23 +1573,31 @@
 
     RuleElementItf *itfre=rule->getItf();   assert(itfre);
 
-    if ( !itfre->isAny() &&
-         rule->getDirection()==PolicyRule::Both )
-//        rule->getAction() != PolicyRule::Classify)
+    if ( !itfre->isAny() && rule->getDirection()==PolicyRule::Both)
     {
 	PolicyRule *r;
 
-	r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
-	compiler->temp_ruleset->add(r);
-	r->duplicate(rule);
-	r->setDirection( PolicyRule::Inbound );
-	tmp_queue.push_back(r);
+        // If this rule has been assigned to chain POSTROUTING,
+        // direction 'inbound' does not make sense for it.
+        if (rule->getStr("ipt_chain") != "POSTROUTING")
+        {
+            r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+            compiler->temp_ruleset->add(r);
+            r->duplicate(rule);
+            r->setDirection( PolicyRule::Inbound );
+            tmp_queue.push_back(r);
+        }
 
-	r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
-	compiler->temp_ruleset->add(r);
-	r->duplicate(rule);
-	r->setDirection( PolicyRule::Outbound );
-	tmp_queue.push_back(r);
+        // If this rule has been assigned to chain PREROUTING,
+        // direction 'Outbound' does not make sense for it.
+        if (rule->getStr("ipt_chain") != "PREROUTING")
+        {
+            r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+            compiler->temp_ruleset->add(r);
+            r->duplicate(rule);
+            r->setDirection( PolicyRule::Outbound );
+            tmp_queue.push_back(r);
+        }
     } else
 	tmp_queue.push_back(rule);
 
@@ -1703,14 +1857,9 @@
 
 bool PolicyCompiler_ipt::splitIfSrcAny::processNext()
 {
+    PolicyCompiler_ipt *ipt_comp=dynamic_cast<PolicyCompiler_ipt*>(compiler);
     PolicyRule *rule=getNext(); if (rule==NULL) return false;
 
-    if (rule->getAction() == PolicyRule::Classify)
-    {
-	tmp_queue.push_back(rule);
-	return true;
-    }
-
 //    FWOptions *fwopt    = compiler->getCachedFwOpt();
     FWOptions  *ruleopt = rule->getOptionsObject();
 /* commented to fix bug #1112470
@@ -1752,6 +1901,21 @@
         r->setStr("ipt_chain","OUTPUT");
         r->setDirection( PolicyRule::Outbound );
         tmp_queue.push_back(r);
+
+        // if this rule is for mangle table, need to put it into
+        // POSTROUTING chain as well because some targets that
+        // work with mangle table can only go into POSTROUTING chain
+        // such as CLASSIFY
+        if (ipt_comp->my_table=="mangle" && rule->getAction()==PolicyRule::Classify)
+        {
+            r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+            compiler->temp_ruleset->add(r);
+            r->duplicate(rule);
+            r->setStr("ipt_chain","POSTROUTING");
+            r->setDirection( PolicyRule::Outbound );
+            tmp_queue.push_back(r);
+        }
+
     }
     tmp_queue.push_back(rule);  // add old rule anyway
 
@@ -1760,14 +1924,9 @@
 
 bool PolicyCompiler_ipt::splitIfDstAny::processNext()
 {
+    PolicyCompiler_ipt *ipt_comp=dynamic_cast<PolicyCompiler_ipt*>(compiler);
     PolicyRule *rule=getNext(); if (rule==NULL) return false;
 
-    if (rule->getAction() == PolicyRule::Classify)
-    {
-	tmp_queue.push_back(rule);
-	return true;
-    }
-
 //    FWOptions *fwopt = compiler->getCachedFwOpt();
     FWOptions  *ruleopt = rule->getOptionsObject();
 /* commented to fix bug #1112470
@@ -1808,6 +1967,21 @@
 	r->setStr("ipt_chain","INPUT");
 	r->setDirection( PolicyRule::Inbound );
 	tmp_queue.push_back(r);
+
+        // if this rule is for mangle table, need to put it into
+        // POSTROUTING chain as well because some targets that
+        // work with mangle table can only go into POSTROUTING chain
+        // such as CLASSIFY
+        if (ipt_comp->my_table=="mangle" && rule->getAction()==PolicyRule::Classify)
+        {
+            r= PolicyRule::cast(compiler->dbcopy->create(PolicyRule::TYPENAME) );
+            compiler->temp_ruleset->add(r);
+            r->duplicate(rule);
+            r->setStr("ipt_chain","PREROUTING");
+            r->setDirection( PolicyRule::Inbound );
+            tmp_queue.push_back(r);
+        }
+
     }
     tmp_queue.push_back(rule); // add old rule in any case
 
@@ -2556,48 +2730,67 @@
 
     rule->setStr("ipt_chain","FORWARD");
 
+    if (ipt_comp->my_table=="mangle")
+    {
+        switch ( rule->getDirection() ) 
+        {
+        case PolicyRule::Inbound:
+            rule->setStr("ipt_chain","PREROUTING");
+            break;
+        case PolicyRule::Outbound:
+            rule->setStr("ipt_chain","POSTROUTING");
+            break;
+        default:
+            rule->setStr("ipt_chain","FORWARD");
+            break;
+        }
+    } else
+    {
+
 //    RuleElementSrc *srcrel=rule->getSrc();
-    Address        *src   =compiler->getFirstSrc(rule);  assert(src);
+      Address        *src   =compiler->getFirstSrc(rule);  assert(src);
 //    RuleElementDst *dstrel=rule->getDst();
-    Address        *dst   =compiler->getFirstDst(rule);  assert(dst);
+      Address        *dst   =compiler->getFirstDst(rule);  assert(dst);
 
-    bool b,m;
+      bool b,m;
 /* 
  * do not check for broadcasts and multicasts in bridging firewall because
  * they should go to FORWARD chain 
  */
-    b=m= !( compiler->getCachedFwOpt()->getBool("bridging_fw") );
+      b=m= !( compiler->getCachedFwOpt()->getBool("bridging_fw") );
 
-    switch ( rule->getDirection() ) 
-    {
-    case PolicyRule::Inbound:
+      switch ( rule->getDirection() ) 
+      {
+      case PolicyRule::Inbound:
 /* if direction is "Inbound", chain can never be OUTPUT, but could be FORWARD */
-        if (!dst->isAny() && ipt_comp->complexMatch(dst,ipt_comp->fw,b,m))
-            rule->setStr("ipt_chain","INPUT");
+          if (!dst->isAny() && ipt_comp->complexMatch(dst,ipt_comp->fw,b,m))
+              rule->setStr("ipt_chain","INPUT");
 
-        break;
+          break;
 
-    case PolicyRule::Outbound:
+      case PolicyRule::Outbound:
 /* if direction is "Outbound", chain can never be INPUT, but could be FORWARD */
-        if (!src->isAny() && ipt_comp->complexMatch(src,ipt_comp->fw,b,m))
-            rule->setStr("ipt_chain","OUTPUT");
+          if (!src->isAny() && ipt_comp->complexMatch(src,ipt_comp->fw,b,m))
+              rule->setStr("ipt_chain","OUTPUT");
 
-        break;
+          break;
 
-    default:
+      default:
 
 /* direction == Both */
-        if (!dst->isAny() && ipt_comp->complexMatch(dst,ipt_comp->fw,b,m)) 
-        {
-            rule->setStr("ipt_chain","INPUT");
-            break;
-        }
-        if (!src->isAny() && ipt_comp->complexMatch(src,ipt_comp->fw,b,m)) 
-        {
-            rule->setStr("ipt_chain","OUTPUT");
-            break;
-        }
+          if (!dst->isAny() && ipt_comp->complexMatch(dst,ipt_comp->fw,b,m)) 
+          {
+              rule->setStr("ipt_chain","INPUT");
+              break;
+          }
+          if (!src->isAny() && ipt_comp->complexMatch(src,ipt_comp->fw,b,m)) 
+          {
+              rule->setStr("ipt_chain","OUTPUT");
+              break;
+          }
+      }
     }
+
 /*
  * bug #1040599: "unnecessary FORWARD rules".
  * If we haven't decided on INPUT/OUTPUT chain, it stays FORWARD.
@@ -3356,7 +3549,21 @@
             add( new ExpandMultipleAddressesInSRC("expand objects with multiple addresses in SRC" ) );
             add( new ExpandMultipleAddressesInDST("expand objects with multiple addresses in DST" ) );
             add( new ConvertToAtomic("convert to atomic rules"            ) );
-            add( new DetectShadowing("Detect shadowing"                   ) );
+
+/*
+ * This assumes that all rules that go into the mangle table are
+ * non-terminating. This is not necessarily correct because
+ * non-termination is really an attribute of the target. However
+ * targets that we support that go into mangle table (CLASSIFY and
+ * MARK) are indeed non-terminating.
+ */
+
+            
+            if (my_table=="mangle" && !fw->getOptionsObject()->getBool("classify_mark_terminating"))
+                add( new DetectShadowingForNonTerminatingRules("Detect shadowing for non-terminating rules" ) );
+            else
+                add( new DetectShadowing("Detect shadowing"                   ) );
+
             add( new simplePrintProgress(                                 ) );
 
             runRuleProcessors();
@@ -3377,8 +3584,12 @@
 
         add( new Route(           "process route rules"                   ) );
         add( new storeAction(     "store original action of this rule"    ) );
+
+// *** call  setChainIfTagInPrerouting BEFORE splitIfIfaceAndDirectionBoth ! ***
         add( new setChainIfTagInPrerouting("handle Tag in PREROUTING chain") );
         add( new splitIfTagAndConnmark( "handle Tag in combination with CONNMARK"));
+        add( new setChainForMangle(        "set chain for other rules in mangle table") );
+
         add( new Logging1(        "check global logging override option"  ) );
         add( new ItfNegation(     "process negation in Itf"  ) );
 
@@ -3387,6 +3598,8 @@
         add( new decideOnChainForClassify("assign chain if action is Classify") );
 
         add( new InterfaceAndDirection("fill in interface and direction"  ) );
+
+// if an action requires chain POSTROUTING (e.g. Classify), set chain BEFORE calling splitIfIfaceAndDirectionBoth
         add( new splitIfIfaceAndDirectionBoth( "split interface rule with direction 'both'") );
 
         if (check_for_recursive_groups)
@@ -3539,6 +3752,9 @@
         add( new optimize2(        "optimization 2"                        ) );
         add( new accounting(       "Accounting"                            ) );
         add( new prepareForMultiport("prepare for multiport"               ) );
+
+        add( new splitNonTerminatingTargets( "split rules using non-terminating targets" ) );
+
         add( new ConvertToAtomicForAddresses("convert to atomic rules by address elements") );
 
         add( new checkForZeroAddr(   "check for zero addresses"            ) );
@@ -3593,28 +3809,32 @@
 
         str << endl;
 
-        string src=" ";
-        string dst=" ";
+        ostringstream src;
+        ostringstream dst;
         string srv=" ";
         string time=" ";
         string itf=" ";
 
-        if (srcrel->getNeg()) src="!";
-        if (dstrel->getNeg()) dst="!";
-        if (srvrel->getNeg()) srv="!";
-        if (intrel->getNeg()) time="!";
-        if (itfrel->getNeg()) itf="!";
+        if (srcrel->getNeg()) src << "!";
+        if (dstrel->getNeg()) dst << "!";
+        if (srvrel->getNeg()) srv  = "!";
+        if (intrel->getNeg()) time = "!";
+        if (itfrel->getNeg()) itf  = "!";
 
         if (i1!=srcrel->end()) {
             FWObject *o=*i1;
             if (FWReference::cast(o)!=NULL) o=FWReference::cast(o)->getPointer();
-            src+=o->getName();
+            src << o->getName();
+            if (Group::cast(o)!=NULL)
+                src << "[" << o->size() << "]";
         }
 
         if (i2!=dstrel->end()) {
             FWObject *o=*i2;
             if (FWReference::cast(o)!=NULL) o=FWReference::cast(o)->getPointer();
-            dst+=o->getName();
+            dst << o->getName();
+            if (Group::cast(o)!=NULL)
+                dst << "[" << o->size() << "]";
         }
 
         if (i3!=srvrel->end()) {
@@ -3643,11 +3863,11 @@
         
         str <<  setw(15-w)  << setfill(' ') << " ";
 
-        str <<  setw(18) << setfill(' ') << src.c_str();
-        str <<  setw(18) << setfill(' ') << dst.c_str();
+        str <<  setw(18) << setfill(' ') << src.str();
+        str <<  setw(18) << setfill(' ') << dst.str();
         str <<  setw(12) << setfill(' ') << srv.c_str();
         str <<  setw(10) << setfill(' ') << time.c_str();
-        str <<  setw(8) << setfill(' ') << itf.c_str();
+        str <<  setw(8)  << setfill(' ') << itf.c_str();
 
         if (no==0)
         {
diff -uNr fwbuilder-2.1.8/src/ipt/PolicyCompiler_ipt.h fwbuilder-2.1.9/src/ipt/PolicyCompiler_ipt.h
--- fwbuilder-2.1.8/src/ipt/PolicyCompiler_ipt.h	2006-11-10 06:24:48.000000000 +0100
+++ fwbuilder-2.1.9/src/ipt/PolicyCompiler_ipt.h	2007-01-05 07:47:06.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: PolicyCompiler_ipt.h,v 1.25 2006/11/10 05:24:48 vkurland Exp $
+  $Id: PolicyCompiler_ipt.h,v 1.27 2007/01/05 06:47:06 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -301,6 +301,12 @@
         DECLARE_POLICY_RULE_PROCESSOR(setChainIfTagInPrerouting);
 
 	/**
+	 * set chain for mangle table
+	 */
+        DECLARE_POLICY_RULE_PROCESSOR(setChainForMangle);
+
+        
+	/**
 	 * split rule if action is Tag and connmark option is activated
 	 */
         DECLARE_POLICY_RULE_PROCESSOR(splitIfTagAndConnmark);
@@ -557,6 +563,13 @@
          */
         DECLARE_POLICY_RULE_PROCESSOR(decideOnChainForClassify);
 
+        /**
+         * find non-terminating targets (such as MARK and
+         * CLASSIFY). Put such rule in a separate chain and pass
+         * control to it using "-g"
+         */
+        DECLARE_POLICY_RULE_PROCESSOR(splitNonTerminatingTargets);
+
 	/**
 	 * decides what chain this rule should go to if it has not
 	 * been decided in decideOnChainIfFW
diff -uNr fwbuilder-2.1.8/src/ipt/PolicyCompiler_ipt_optimizer.cpp fwbuilder-2.1.9/src/ipt/PolicyCompiler_ipt_optimizer.cpp
--- fwbuilder-2.1.8/src/ipt/PolicyCompiler_ipt_optimizer.cpp	2006-09-09 07:05:01.000000000 +0200
+++ fwbuilder-2.1.9/src/ipt/PolicyCompiler_ipt_optimizer.cpp	2006-12-28 07:00:23.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: PolicyCompiler_ipt_optimizer.cpp,v 1.9 2006/09/09 05:05:01 vkurland Exp $
+  $Id: PolicyCompiler_ipt_optimizer.cpp,v 1.10 2006/12/28 06:00:23 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -87,16 +87,18 @@
             } else
             {
                RuleElement *re=RuleElement::cast(rule->getFirstByType((*i)->getTypeName()));
+/* 
+ * put "any tcp" service back in srv field if it was originally some
+ * tcp service. This is needed because we may need to produce
+ * --reject-with tcp-reset if the action is reject and we need to
+ * reject with TCP RST.
+ */
+
                if (RuleElementSrv::isA(re) &&
-                   rule->getAction()==PolicyRule::Reject &&
+                   r->getAction()==PolicyRule::Reject &&
                    ipt_comp->isActionOnRejectTCPRST(r))
                {
                    Service  *srv= compiler->getFirstSrv(r);
-/* need to put "any tcp" service back in srv field if it was
- * originally some tcp service. this is needed because we may need to
- * produce --reject-with tcp-reset if the action is reject and we need
- * to reject with TCP RST
- */
                    if (TCPService::isA(srv))
                    {
                        re->clearChildren();
@@ -119,9 +121,12 @@
     }
     r->setStr("ipt_target",new_chain);
     tmp_queue.push_back(r);
+
     FWOptions *ruleopt=rule->getOptionsObject();
     ruleopt->setBool("stateless",true);
     ruleopt->setInt("limit_value",-1);
+    ruleopt->setInt("connlimit_value",-1);
+    ruleopt->setInt("hashlimit_value",-1);
     rule->setStr("ipt_chain",new_chain);
     rule->setBool("force_state_check",false);
     rule->setStr("upstream_rule_chain",this_chain);
diff -uNr fwbuilder-2.1.8/src/ipt/PolicyCompiler_PrintRule.cpp fwbuilder-2.1.9/src/ipt/PolicyCompiler_PrintRule.cpp
--- fwbuilder-2.1.8/src/ipt/PolicyCompiler_PrintRule.cpp	2006-11-10 06:47:26.000000000 +0100
+++ fwbuilder-2.1.9/src/ipt/PolicyCompiler_PrintRule.cpp	2007-01-15 02:21:58.000000000 +0100
@@ -6,7 +6,7 @@
 
   Author:  Vadim Kurland     vadim@vk.crocodile.org
 
-  $Id: PolicyCompiler_PrintRule.cpp,v 1.31 2006/11/10 05:47:26 vkurland Exp $
+  $Id: PolicyCompiler_PrintRule.cpp,v 1.33 2007/01/15 01:21:58 vkurland Exp $
 
   This program is free software which we release under the GNU General Public
   License. You may redistribute and/or modify this program under the terms
@@ -256,7 +256,7 @@
 
     if ( compiler->getCachedFwOpt()->getBool("use_ULOG") &&
          target=="LOG") target="ULOG";
-    
+
     ostr << " -j " << target << " ";
 
     if (target=="REJECT")
diff -uNr fwbuilder-2.1.8/VERSION fwbuilder-2.1.9/VERSION
--- fwbuilder-2.1.8/VERSION	2006-12-03 17:42:24.000000000 +0100
+++ fwbuilder-2.1.9/VERSION	2007-02-10 23:49:08.000000000 +0100
@@ -1,10 +1,10 @@
 #-*- mode: shell-script; tab-width: 4; -*-
-# $Id: VERSION,v 1.36 2006/12/03 16:42:24 vkurland Exp $
+# $Id: VERSION,v 1.38 2007/02/10 22:49:08 vkurland Exp $
 
 
 FWB_MAJOR_VERSION=2
 FWB_MINOR_VERSION=1
-FWB_MICRO_VERSION=8
+FWB_MICRO_VERSION=9
 VERSION=$FWB_MAJOR_VERSION.$FWB_MINOR_VERSION.$FWB_MICRO_VERSION
 
 #
@@ -21,7 +21,7 @@
 
 BETA="no"
 
-REQUIRED_LIBFWBUILDER_VERSION="2.1.8"
+REQUIRED_LIBFWBUILDER_VERSION="2.1.9"
 
 # current (or major) version number of the library so file
 #
diff -uNr fwbuilder-2.1.8/VERSION.h fwbuilder-2.1.9/VERSION.h
--- fwbuilder-2.1.8/VERSION.h	2006-12-03 17:44:28.000000000 +0100
+++ fwbuilder-2.1.9/VERSION.h	2007-02-11 04:39:14.000000000 +0100
@@ -1,2 +1,2 @@
-#define VERSION      "2.1.8"
+#define VERSION      "2.1.9"
 #define RELEASE_NUM  "1"
